indexing
	description: "Test Driver with output on the console"
	author: "Peter Brandt and Martin Geisler"
	date: "$Date: 2005-06-23 17:56:56 +0200 (Thu, 23 Jun 2005) $"
	revision: "$Revision: 90 $"

class
	CONSOLE_TEST_DRIVER

inherit
	TEST_DRIVER
		redefine
			make
		end

	INTERFACE_SHARED

create
	make

feature -- Initialization

	make is
			-- Creation procedure
		do
			Precursor
			execute_started_actions.extend (agent execution_started_action)
			test_executed_actions.extend (agent record_progres)			
			execute_finished_actions.extend (agent execution_finished_action)
		end

feature {NONE} -- Implementation

	execution_started_action is
			-- Print welcome banner
		do
			io.put_string ("%N")
			io.put_string (dividing_line)
			io.put_string ("Executing " + count.out + " Test Cases%N")
			io.put_string (dividing_line)
		end
	
	execution_finished_action is
			-- Print execution statistics
		do
			io.put_string (dividing_line)

			io.put_string ("Test Execution Statistics%N")

			io.put_string (dividing_line)
			
			io.put_string (Passed_label_text + passed.out + "%N")
			io.put_string (Failed_label_text + failed.out + "%N")
			io.put_string (Total_label_text + " " + count.out + "%N")
			
			io.put_string (dividing_line)
		end

	record_progres (test: TEST_CASE) is
			-- Record execution of `test'
		do
			if test.has_failed then
				io.put_string (test.name + ": " + Failed_text + "%N")
				io.put_string ("%T" + test.tag_name
					+ " in {" + test.class_name + "}."
					+ test.routine_name + "%N")
			else
				io.put_string (test.name + ": " + Passed_text + "%N")
			end			
		end	

	dividing_line: STRING is "------------------------------------------------%N"
			-- A line of stars

end -- class CONSOLE_TEST_DRIVER
