indexing
	description: "String constants and utility routines"
	author: "Peter Brandt and Martin Geisler"
	date: "$Date: 2005-06-25 16:07:43 +0200 (Sat, 25 Jun 2005) $"
	revision: "$Revision: 101 $"

class
	INTERFACE_SHARED

feature -- Access

	Widget_margin: INTEGER is 4
			-- Margin around all widgets

	Graphical_test_driver_window_title: STRING is "Graphical Test Driver"
			-- Title for Graphical Test Driver window

	Saved_state_inspector_window_title: STRING is "Saved State Inspector"
			-- Title for Saved State Inspector window

	Start_button_text: STRING is "Execute Test Cases"
			-- Text on Start button
	
	Previous_button_text: STRING is "Previous Test"
			-- Text on Previous button
	
	Next_button_text: STRING is "Next Test"
			-- Text on Next button
	
	Detail_button_text: STRING is "Examine Saved States"
			-- Text on Examine Test button
	
	Progress_frame_text: STRING is "Overall Progress"
			-- Text on Progress frame

	Detail_frame_text: STRING is "Test Detail"
			-- Text on Detail frame
	
	Passed_label_text: STRING is "Passed: "
			-- Text on label with number of passed tests

	Failed_label_text: STRING is "Failed: "
			-- Text on label with number of failed tests

	Total_label_text: STRING is "Total: "
			-- Text on label with total number of tests
	
	Test_name_label_text: STRING is "Test name: "
			-- Text on test name label

	Class_label_text: STRING is "Class: "
			-- Text on class name label

	Routine_label_text: STRING is "Routine: "
			-- Text on routine name label

	Tag_label_text: STRING is "Tag: "
			-- Text on assertion tag label

	Violation_type_label_text: STRING is "Violation Type: "
			-- Text on violation type label
	
	Status_label_text: STRING is "Status: "
			-- Text on test status label

	Passed_text: STRING is "Passed"
			-- Test passed text

	Failed_text: STRING is "Failed!"
			-- Test failed text

	None_text: STRING is "None"
			-- No status text

	Saved_state_frame_text: STRING is "Saved State "
			-- Text on the Saved State frame
	
	Routine_arguments_text: STRING is "Routine Arguments"
			-- Text on routine arguments tree item

	Current_object_text: STRING is "Current Object"
			-- Text on current object tree item

	Next_saved_state_text: STRING is "Next Saved State"
			-- Text on next state button
		
	Previous_saved_state_text: STRING is "Previous Saved State"
			-- Text on previous state button

feature -- Access / Exception texts

	Void_call_target_text: STRING is "Feature applied to void reference"
			-- Text for violation type label on `Void_call_target' exception

	No_more_memory_text: STRING is "Failed memory allocation"
			-- Text for violation type label on `No_more_memory' exception

	Precondition_text: STRING is "Violated precondition"
			-- Text for violation type label on `Precondition' exception

	Postcondition_text: STRING is "Violated postcondition"
			-- Text for violation type label on `Postcondition' exception

	Floating_point_exception_text: STRING is "Floating point exception"
			-- Text for violation type label on `Floating_point_exception' exception

	Class_invariant_text: STRING is "Violated class invariant"
			-- Text for violation type label on `Class_invariant' exception

	Check_instruction_text: STRING is "Violated check"
			-- Text for violation type label on `Check_instruction' exception

	Routine_failure_text: STRING is "Failed routine"
			-- Text for violation type label on `Routine_failure' exception

	Incorrect_inspect_value_text: STRING is "Inspect value which is not one of the inspect constants, if there is no Else_part"
			-- Text for violation type label on `Incorrect_inspect_value' exception

	Loop_variant_text: STRING is "Non-decreased loop variant"
			-- Text for violation type label on `Loop_variant' exception

	Loop_invariant_text: STRING is "Violated loop invariant"
			-- Text for violation type label on `Loop_invariant' exception

	Signal_exception_text: STRING is "Operating system signal"
			-- Text for violation type label on `Signal_exception' exception

	Rescue_exception_text: STRING is "Exception in rescue clause"
			-- Text for violation type label on `Rescue_exception' exception

	External_exception_text: STRING is "Operating system error which does not set the `errno' variable"
			-- Text for violation type label on `External_exception' exception

	Void_assigned_to_expanded_text: STRING is "Assignment of void value to expanded entity"
			-- Text for violation type label on `Void_assigned_to_expanded' exception

	Io_exception_text: STRING is "I/O error"
			-- Text for violation type label on `Io_exception' exception

	Operating_system_exception_text: STRING is "Operating system error which sets the `errno' variable"
			-- Text for violation type label on `Operating_system_exception' exception

	Retrieve_exception_text: STRING is "Retrieval error may be raised by `retrieved' in `IO_MEDIUM'."
			-- Text for violation type label on `Retrieve_exception' exception

	Developer_exception_text: STRING is "Developer exception"
			-- Text for violation type label on `Developer_exception' exception

	Runtime_io_exception_text: STRING is "I/O error raised by runtime functions such as store/retrieve, file access..."
			-- Text for violation type label on `Runtime_io_exception' exception

	Com_exception_text: STRING is "COM error."
			-- Text for violation type label on `Com_exception' exception

	Runtime_check_exception_text: STRING is "Runtime check being violated."
			-- Text for violation type label on `Runtime_check_exception' exception

	Unknown_exception_text: STRING is "Unknown exception"
			-- Text for violation type label for unknown exceptions



feature -- Basic operations

	left_align (widget: EV_WIDGET): EV_HORIZONTAL_BOX is
			-- Pack `widget' left aligned in a `EV_HORIZONTAL_BOX'
		do
			create Result
			Result.extend (widget)
			Result.extend (create {EV_CELL})
			Result.disable_item_expand (widget)
		end

end -- class INTERFACE_SHARED
